
package de.ivu.elect.presentation.benutzerverwaltung;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.benutzerverwaltung.boundary.NachrichtBoundaryCreate;
import de.ivu.elect.business.benutzerverwaltung.entity.Nachricht;
import de.ivu.elect.business.benutzerverwaltung.entity.NachrichtMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractNachrichtCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractNachrichtCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.NACHRICHT_CREATE)
public abstract class AbstractNachrichtCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Nachricht> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "nachrichtCreateView";

  public static final String VIEW_ID = "/benutzerverwaltung/nachricht-create.xhtml";

  public static final String PARENT_VIEW_ID = "/benutzerverwaltung/nachricht-search.xhtml";

  @Inject
  protected transient NachrichtBoundaryCreate create;

  protected Nachricht entity;

  @Inject
  protected transient NachrichtMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  Nachricht());
  }

  

  public Nachricht getEntity() {
    return entity;
  }

  protected void setEntity(Nachricht entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.NACHRICHT_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Nachricht entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Nachricht entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.NACHRICHT_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
